searchNodes=[{"doc":"Formats and rewrites the given files and patterns. mix style mix.exs &quot;lib/ /*.{ex,exs}&quot; &quot;test/ /*.{ex,exs}&quot; mix style uses the same options as mix format specified in .formatter.exs to format the code, and to determine which files to style if you don't pass any as arguments Task-specific options --check-formatted - an alias for --check-styled , included for compatibility with mix format --check-styled - checks that the file is already styled rather than styling it. useful for CI.","ref":"Mix.Tasks.Style.html","title":"Mix.Tasks.Style","type":"task"},{"doc":"A Style takes AST and returns a transformed version of that AST. Because these transformations involve traversing trees (the &quot;T&quot; in &quot;AST&quot;), we wrap the AST in a structure called a Zipper to facilitate walking the trees.","ref":"Styler.Style.html","title":"Styler.Style","type":"behaviour"},{"doc":"run will be used with Zipper.traverse_while/3 , meaning it will be executed on every node of the AST. You can skip traversing parts of the tree by returning a Zipper that's further along in the traversal, for example by calling Zipper.skip(zipper) to skip an entire subtree you know is of no interest to your Style.","ref":"Styler.Style.html#c:run/1","title":"Styler.Style.run/1","type":"callback"},{"doc":"","ref":"Styler.Style.html#t:command/0","title":"Styler.Style.command/0","type":"type"},{"doc":"Styles up aliases! This Style will expand multi-aliases and sort aliases within their groups. It also adds a newline after all alias groups. Rewrites for the following Credo rules: Credo.Check.Readability.AliasOrder Credo.Check.Readability.MultiAlias Credo.Check.Readability.UnnecessaryAliasExpansion This module is more particular than credo for sorting. Notably, it sorts alias __MODULE__ , whereas Credo allowed that alias intermixed anywhere in a group.","ref":"Styler.Style.Aliases.html","title":"Styler.Style.Aliases","type":"module"},{"doc":"Callback implementation for Styler.Style.run/1 .","ref":"Styler.Style.Aliases.html#run/1","title":"Styler.Style.Aliases.run/1","type":"function"},{"doc":"NOT ENABLED Currently has a bug where it puts comments into bad places no matter what, since it's always rewriting every head. It's been run on our codebase once though... Styles function heads so that they're as small as possible. The goal is that a function head fits on a single line. This isn't a Credo issue, and the formatter is fine with either approach. But Styler has opinions! Ex: This long declaration def foo ( %{ bar : baz } ) do ... end Becomes def foo ( %{ bar : baz } ) do ... end","ref":"Styler.Style.Defs.html","title":"Styler.Style.Defs","type":"module"},{"doc":"Callback implementation for Styler.Style.run/1 .","ref":"Styler.Style.Defs.html#run/1","title":"Styler.Style.Defs.run/1","type":"function"},{"doc":"Styles pipes! In particular, don't make pipe chains of only one pipe, and some persnickety pipe chain start stuff. Rewrites for the following Credo rules: Credo.Check.Readability.BlockPipe Credo.Check.Readability.SinglePipe Credo.Check.Refactor.PipeChainStart, excluded_functions: [&quot;from&quot;]","ref":"Styler.Style.Pipes.html","title":"Styler.Style.Pipes","type":"module"},{"doc":"Callback implementation for Styler.Style.run/1 .","ref":"Styler.Style.Pipes.html#run/1","title":"Styler.Style.Pipes.run/1","type":"function"},{"doc":"Branched from https://github.com/doorgan/sourceror/blob/main/lib/sourceror/zipper.ex , see this issue for context on branching: https://github.com/doorgan/sourceror/issues/67 Implements a Zipper for the Elixir AST based on Gérard Huet Functional pearl: the zipper paper and Clojure's clojure.zip API. A zipper is a data structure that represents a location in a tree from the perspective of the current node, also called focus . It is represented by a 2-tuple where the first element is the focus and the second element is the metadata/context. The metadata is nil when the focus is the topmost node","ref":"Styler.Zipper.html","title":"Styler.Zipper","type":"module"},{"doc":"Inserts the item as the rightmost child of the node at this zipper, without moving.","ref":"Styler.Zipper.html#append_child/2","title":"Styler.Zipper.append_child/2","type":"function"},{"doc":"Returns true if the node is a branch.","ref":"Styler.Zipper.html#branch?/1","title":"Styler.Zipper.branch?/1","type":"function"},{"doc":"Returns a list of children of the node.","ref":"Styler.Zipper.html#children/1","title":"Styler.Zipper.children/1","type":"function"},{"doc":"Returns the zipper of the leftmost child of the node at this zipper, or nil if no there's no children.","ref":"Styler.Zipper.html#down/1","title":"Styler.Zipper.down/1","type":"function"},{"doc":"Returns a zipper to the node that satisfies the predicate function, or nil if none is found. The optional second parameters specifies the direction , defaults to :next .","ref":"Styler.Zipper.html#find/3","title":"Styler.Zipper.find/3","type":"function"},{"doc":"Inserts the item as the leftmost child of the node at this zipper, without moving.","ref":"Styler.Zipper.html#insert_child/2","title":"Styler.Zipper.insert_child/2","type":"function"},{"doc":"Inserts the item as the left sibling of the node at this zipper, without moving. Raises an ArgumentError when attempting to insert a sibling at the top level.","ref":"Styler.Zipper.html#insert_left/2","title":"Styler.Zipper.insert_left/2","type":"function"},{"doc":"Inserts the item as the right sibling of the node at this zipper, without moving. Raises an ArgumentError when attempting to insert a sibling at the top level.","ref":"Styler.Zipper.html#insert_right/2","title":"Styler.Zipper.insert_right/2","type":"function"},{"doc":"Returns the zipper of the left sibling of the node at this zipper, or nil.","ref":"Styler.Zipper.html#left/1","title":"Styler.Zipper.left/1","type":"function"},{"doc":"Returns the leftmost sibling of the node at this zipper, or itself.","ref":"Styler.Zipper.html#leftmost/1","title":"Styler.Zipper.leftmost/1","type":"function"},{"doc":"Returns a new branch node, given an existing node and new children.","ref":"Styler.Zipper.html#make_node/2","title":"Styler.Zipper.make_node/2","type":"function"},{"doc":"Returns the following zipper in depth-first pre-order.","ref":"Styler.Zipper.html#next/1","title":"Styler.Zipper.next/1","type":"function"},{"doc":"Returns the node at the zipper.","ref":"Styler.Zipper.html#node/1","title":"Styler.Zipper.node/1","type":"function"},{"doc":"Returns the previous zipper in depth-first pre-order. If it's already at the end, it returns nil.","ref":"Styler.Zipper.html#prev/1","title":"Styler.Zipper.prev/1","type":"function"},{"doc":"Removes the node at the zipper, returning the zipper that would have preceded it in a depth-first walk.","ref":"Styler.Zipper.html#remove/1","title":"Styler.Zipper.remove/1","type":"function"},{"doc":"Replaces the current node in the zipper with a new node.","ref":"Styler.Zipper.html#replace/2","title":"Styler.Zipper.replace/2","type":"function"},{"doc":"Returns the zipper of the right sibling of the node at this zipper, or nil.","ref":"Styler.Zipper.html#right/1","title":"Styler.Zipper.right/1","type":"function"},{"doc":"Returns the rightmost sibling of the node at this zipper, or itself.","ref":"Styler.Zipper.html#rightmost/1","title":"Styler.Zipper.rightmost/1","type":"function"},{"doc":"Walks the zipper all the way up and returns the root node.","ref":"Styler.Zipper.html#root/1","title":"Styler.Zipper.root/1","type":"function"},{"doc":"Returns the zipper of the right sibling of the node at this zipper, or the next zipper when no right sibling is available. This allows to skip subtrees while traversing the siblings of a node. The optional second parameters specifies the direction , defaults to :next . If no right/left sibling is available, this function returns the same value as next/1 / prev/1 . The function skip/1 behaves like the :skip in traverse_while/2 and traverse_while/3 .","ref":"Styler.Zipper.html#skip/2","title":"Styler.Zipper.skip/2","type":"function"},{"doc":"Walks the zipper all the way up and returns the top zipper.","ref":"Styler.Zipper.html#top/1","title":"Styler.Zipper.top/1","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node. If the zipper is not at the top, just the subtree will be traversed. The function must return a zipper.","ref":"Styler.Zipper.html#traverse/2","title":"Styler.Zipper.traverse/2","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node with an accumulator. If the zipper is not at the top, just the subtree will be traversed.","ref":"Styler.Zipper.html#traverse/3","title":"Styler.Zipper.traverse/3","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node. The traversing will continue if the function returns {:cont, zipper} , skipped for {:skip, zipper} and halted for {:halt, zipper} If the zipper is not at the top, just the subtree will be traversed. The function must return a zipper.","ref":"Styler.Zipper.html#traverse_while/2","title":"Styler.Zipper.traverse_while/2","type":"function"},{"doc":"Traverses the tree in depth-first pre-order calling the given function for each node with an accumulator. The traversing will continue if the function returns {:cont, zipper, acc} , skipped for {:skip, zipper, acc} and halted for {:halt, zipper, acc} If the zipper is not at the top, just the subtree will be traversed.","ref":"Styler.Zipper.html#traverse_while/3","title":"Styler.Zipper.traverse_while/3","type":"function"},{"doc":"Returns the zipper of the parent of the node at this zipper, or nil if at the top.","ref":"Styler.Zipper.html#up/1","title":"Styler.Zipper.up/1","type":"function"},{"doc":"Replaces the current node in the zipper with the result of applying fun to the node.","ref":"Styler.Zipper.html#update/2","title":"Styler.Zipper.update/2","type":"function"},{"doc":"Creates a zipper from a tree node.","ref":"Styler.Zipper.html#zip/1","title":"Styler.Zipper.zip/1","type":"function"},{"doc":"","ref":"Styler.Zipper.html#t:path/0","title":"Styler.Zipper.path/0","type":"opaque"},{"doc":"","ref":"Styler.Zipper.html#t:tree/0","title":"Styler.Zipper.tree/0","type":"type"},{"doc":"","ref":"Styler.Zipper.html#t:zipper/0","title":"Styler.Zipper.zipper/0","type":"type"},{"doc":"Wraps errors raised by Styles during tree traversal.","ref":"Styler.StyleError.html","title":"Styler.StyleError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Styler.StyleError.html#message/1","title":"Styler.StyleError.message/1","type":"function"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Improvements Initial release of Styler Added Aliases style, replacing the following Credo rules: Credo.Check.Readability.AliasOrder Credo.Check.Readability.MultiAlias Credo.Check.Readability.UnnecessaryAliasExpansion Added Pipes style, replacing the following Credo rules: Credo.Check.Readability.BlockPipe Credo.Check.Readability.SinglePipe Credo.Check.Refactor.PipeChainStart Added Defs style (currently disabled by default)","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"},{"doc":"Styler is an AST-rewriting tool. Think of it as a combination of mix format and mix credo , except instead of telling you what's wrong, it just rewrites the code for you to fit our style rules. Hence, mix style ! Styler is configuration-free. Like mix format , it runs based on the inputs from .formatter.exs and has opinions rather than configuration.","ref":"readme.html","title":"Styler","type":"extras"},{"doc":"mix style is a 1-1 stand-in for mix format in all the normal use-cases. Run mix help style for help using it. Styler and Comments... Styler is currently unaware of comments, so you may find that it puts them in really odd spots after a rewrite. If you find that a comment was put somewhere weird after using Styler, you'll just have to manually put it back where you want it after. Feel free to grumble about it in an Issue so that we can properly prioritize making this work better in the future.","ref":"readme.html#mix-style","title":"Styler - mix style","type":"extras"},{"doc":"You can find the currently-enabled styles in the Mix.Tasks.Style module, inside of its @styles module attribute. Each Style's moduledoc will tell you more about what it rewrites.","ref":"readme.html#current-styles","title":"Styler - Current Styles","type":"extras"},{"doc":"credo rule style that rewrites to suit Credo.Check.Readability.AliasOrder Styler.Style.Aliases Credo.Check.Readability.MultiAlias Styler.Style.Aliases Credo.Check.Readability.UnnecessaryAliasExpansion Styler.Style.Aliases Credo.Check.Readability.SinglePipe Styler.Style.Pipes Credo.Check.Refactor.PipeChainStart Styler.Style.Pipes","ref":"readme.html#credo-rules-styler-replaces","title":"Styler - Credo Rules Styler Replaces","type":"extras"},{"doc":"Write a new Style by implementing the Styler.Style behaviour. See its moduledoc for more.","ref":"readme.html#writing-styles","title":"Styler - Writing Styles","type":"extras"},{"doc":"This work was inspired by earlier large-scale rewrites of our codebase that used the fantastic tool called Sourceror . The initial implementation of Styler used Sourceror, but Sourceror's AST-embedding comment algorithm causes Styler to be too slow to use as a normal formatter. Still, we're grateful for the inspiration Sourceror provided and the changes to the Elixir AST APIs that it drove. The AST-Zipper implementation in this project was derived mostly from Sourceror's implementation.","ref":"readme.html#where-is-sourceror","title":"Styler - Where is Sourceror?","type":"extras"}]